/*
 * LD48 Competition Entry
 * Author: Moogle or Roelf Leenders
 * Theme: Light and Darkness
 */

Program LightAndDarkness;

Const

//Bug stats
MAX_LIFE = 100;
BASE_LEVEL = 4;

MAX_LEVEL = 4;

//Screen size:
SCREENX = 640;
SCREENY = 480;

//COlours of armies
BLUE = 0;
RED = 1;

//Stats!
MAX_LIGHTS = 50;
MAX_MEMBERS = 500;

//Light types:
TYPE_NORMAL = 1;

ANT_EDGE = 10;

Global

//Score
scores[1];

//Lights
struct light[MAX_LIGHTS];
  sx;
  sy;
  stime;
  stype;
end


//Scroll variables

background_pic = 12;

struct sc[0]
  sx;
  sy;
  sid;
  border[3];
end

//scroll members
int members[MAX_MEMBERS];

//Resource pointers
FPG_Menu;
FPG_Game;
FPG_Levels;
FPG_Levels2;

FNT_1;
FNT_2;

//Store scores
struct player;
  scores[15];
end

//Level names:
String level_name[15] = "","Starting the fight","Double Dutch","Rock around the clock","LudumDare","Easter Egg";
String level_opd[15]  =
"",
"Defeat at least 90% of the population",
"Defeat at least 90% of the population",
"Defeat at least 90% of the population",
"Defeat at least 90% of the population",
"Defeat at least 90% of the population",
"Defeat at least 90% of the population";

levels = 4;
easter_level = 4;

current_level;

Local
ys,xs;
i,j,k,l;
life,colour,damage,level;

Begin
set_fps(34,0);
set_title("BUGS! - Competition Entry LudumDare 48H #1 2005");
full_screen = false;
set_Mode(SCREENX,SCREENY,16);

//Highscores:
if(file_exists("Save/Player.dat"))
  load("Save/Player.dat",player);
else
  player.scores[0] = 1;
  save("Save/Player.dat",player);
end


//Load:
FPG_Menu = load_fpg("FPG/Menu.fpg");
FPG_Game = load_fpg("FPG/Game.fpg");
FPG_Levels=load_fpg("FPG/Levels.fpg");
FPG_Levels2=load_fpg("FPG/Levels2.fpg");
FNT_1 = load_fnt("FNT/Score.fnt");
FNT_2 = load_fnt("FNT/Score2.fnt");
load_pal("FNT/Score.fnt");

//Initialize:
sc.border[0] = 0;
sc.border[1] = 0;
sc.border[2] = 0;
sc.border[3] = 0;


menu();


End

//Menu:
Process menu();

begin
scores[0] = 0;
scores[1] = 1;
let_me_alone();
for(i=0;i<MAX_MEMBERS;i++)
  members[i] = 0;
end
current_level = 0;

put_screen(FPG_Menu,1);

write(0,0,0,0,"Roelf Leenders 2005");

write(FNT_1,250,240,0,"Start Game");
write(FNT_1,250,280,0,"Exit");

graph = write_in_map(FNT_1,"O",0);

loop
  if(key(_up) or key(_down))
    if(k == 1)
      k = 0;
    else
      k = 1;
    end

    while(key(_up) or key(_down))frame;end
  end

  if(key(_enter) or key(_space))
    while(key(_enter) or key(_space))frame;end
    switch(k)
      case 0:
        delete_text(all_text);
        clear_screen();
        levelselect();
        return;
      end
      case 1:
        exit("",0);
      end
    end
  end

  x = 220;
  y = 240 + k*40;

  frame;
end


end


Process levelselect()

begin
delete_text(all_text);
put_screen(FPG_Menu,1);
write(FNT_1,320,200,4,"Level Select");

if(player.scores[MAX_LEVEL-1] == 1)
  levels = MAX_LEVEL + 1;
end

for(i=1;i<=levels;i++)
  write(FNT_1,250+(1-player.scores[i-1])*20,240+(i-1)*40,0,"Level " + i + ": " + level_name[i]);
end



graph = write_in_map(FNT_1,"O",0);
i = 0;
x = 220;
loop
  y = 240 + i*40;
  if(key(_up))
    i = (--i+levels) % levels;
    if(!player.scores[i])
      i = ++i % levels;
    end
    while(key(_up))frame;end
  end

  if(key(_down))
    i = ++i % levels;
    if(!player.scores[i])
      i = (--i+levels) % levels;
    end
    while(key(_down))frame;end
  end

  if(key(_enter) or key(_space))
    while(key(_enter) or key(_space))frame;end
    delete_text(all_text);
    clear_screen();
    unload_map(0,graph);
    startGame(i+1);
    return;
  end

  frame;
end

end




//pauze screen:
Process pauze();

begin

loop

   if(key(_esc))
     i = write(FNT_1,SCREENX/2,SCREENY/2,4,"PAUSE");
     j = write(0,SCREENX/2,SCREENY/2+30,4,"Press Esc to continue, Enter to quit");
     signal(type ant,s_freeze);
     signal(type startgame,s_freeze);
     signal(type overlay,s_freeze);
     signal(type eyes,s_freeze);

     while(key(_esc))frame;end

     loop
       if(key(_enter))exit("",0);end
       if(key(_esc))while(key(_esc))frame;end;break;end
       frame;
     end

     delete_text(i);
     delete_text(j);
     signal(type ant,s_wakeup);
     signal(type startgame,s_wakeup);
     signal(type overlay,s_wakeup);
     signal(type eyes,s_wakeup);
   end
  frame;
end

end


process write_text()

begin

write(0,0,0,0,"FPS:");
write_int(0,140,0,2,&fps);
write(FNT_1,0,50,0,"Blue:");
write_int(FNT_1,140,50,2,&scores[BLUE]);
write(FNT_1,0,80,0,"Red:");
write_int(FNT_1,140,80,2,&scores[RED]);
write(0,0,100,0,"Crush kill and destroy!");
write(0,SCREENX,0,2,"Level " + current_level + ": '" + level_name[current_level] + "'");

end






//Start up a new game
process StartGame(level)

begin
current_level = level;

put_screen(FPG_Menu,1);
put(FPG_Levels2,level,320,350);
write(0,320,190,4,"Level " + level + ":");
write(FNT_1,320,220,4,level_name[level]);
write(0,320,470,4,"Press Enter to start the game");

while(!key(_enter))frame;end
while(key(_enter))frame;end

delete_text(all_text);
clear_screen();

full_screen = true;
set_mode(SCREENX,SCREENY,16);

//Create level from graphic:
sc.border[0] = 0;
sc.border[1] = 0;
sc.border[2] = graphic_info(FPG_Levels,level,G_WIDTH) * 64;
sc.border[3] = graphic_info(FPG_Levels,level,G_HEIGHT) * 64;

for(i = 0;i<graphic_info(FPG_Levels,level,G_WIDTH);i++)
  for(j = 0;j<graphic_info(FPG_Levels,level,G_HEIGHT);j++)
    switch(map_get_pixel(FPG_Levels,level,i,j))

      case 1:
        //Blue Team:
/*        k = 16;
        l = 16;
        ant(i*64 + k,j*64 + l,BLUE,4);
        k = 48;
        ant(i*64 + k,j*64 + l,BLUE,4);
        l = 48;
        ant(i*64 + k,j*64 + l,BLUE,4);
        k = 16;
        ant(i*64 + k,j*64 + l,BLUE,4);
*/
        ant(i*64+32,j*64+32,BLUE,4);
      end
      case 2:
        //Red Team:
/*        k = 16;
        l = 16;
        ant(i*64 + k,j*64 + l,RED,4);
        k = 48;
        ant(i*64 + k,j*64 + l,RED,4);
        l = 48;
        ant(i*64 + k,j*64 + l,RED,4);
        k = 16;
        ant(i*64 + k,j*64 + l,RED,4);
*/
        ant(i*64+32,j*64+32,RED,4);
      end
    end

  end
end
pauze();

overlay();

resolution = 1;

maintain_world();



mouse.graph = 2;
mouse.file = FPG_Menu;


add_scroll(id);
sc.sid = id;
xs = SCREENX/2;
ys = SCREENY/2;
loop

  if(mouse.left)
    while(mouse.left)frame;end
    add_light(mouse.x+sc.sx,mouse.y+sc.sy,TYPE_NORMAL);
  end

  if(mouse.x > SCREENX-10)
    xs+=15;
  end
  if(mouse.x < 10)
    xs-=15;
  end
  if(mouse.y > SCREENY-10)
    ys+=15;
  end
  if(mouse.y < 10)
    ys-=15;
  end
  if(xs < SCREENX/2)xs = SCREENX/2;end
  if(xs > sc.border[2] - SCREENX/2)xs = sc.border[2]-SCREENX/2;end
  if(ys < SCREENY/2)ys = SCREENY/2;end
  if(ys > sc.border[3] - SCREENY/2)ys = sc.border[3] - SCREENY/2;end

  //End of the game:
  if(scores[BLUE] == 0 or scores[RED] == 0 or key(_F11))
    //Game ends:
    delete_text(all_text);
    clear_screen();
    let_me_alone();
    scores[RED] = 0;
    GameEnd();
    return;
  end



  frame;
end

end


process gameend()

private
String title;

begin
mouse.graph = 0;

put_screen(FPG_Menu,1);

full_screen = false;
set_mode(SCREENX,SCREENY,16);

//Empty all variables:
for(i=0;i<MAX_LIGHTS;i++)
  remove_light(i);
end

for(i=0;i<MAX_MEMBERS;i++)
  remove_scroll(i);
end

sc.sid = 0;




if(scores[BLUE] == 0)
  //Game over
  title = "Bugger";
  write(FNT_1,320,200,4,title);
  write(0,320,240,4,"I'm afraid you didn't make it, the red lads");
  write(0,320,250,4,"are still there while your brave hero's are");
  write(0,320,260,4,"somewhere dead waiting for you to try again.");
  write(0,320,270,4,"Please show you care about them and do so NOW.");
  write(FNT_1,320,340,4,"Enter to continue to the main screen");
  while(!key(_enter))frame;end
  while(key(_enter))frame;end
  delete_text(all_text);
  clear_screen();
  menu();
  return;
end

if(scores[RED] == 0)

  player.scores[current_level] = 1;
  save("Save/player.dat",player);

  title = "Total victory";
  write(FNT_1,320,200,4,title);
  write(0,320,240,4,"Brilliant, you just completed level " + current_level);
  if(level == easter_level)
    write(0,320,250,4,"The Easter level even! Well, so far for the secrets");
    write(0,320,260,4,"in this game, that completes your journey through the");
    write(0,320,270,4,"lands of red and blue bugs. Thanks for playing it this");
    write(0,320,280,4,"thoroughly, hope you enjoyed it. Thanks, Roelf.");
  else
    if(level == levels-1)
      write(0,320,250,4,"So that was the last one, congratulations. Of course, to ");
      write(0,320,260,4,"gain the power to call yourself a real man try the freshly");
      write(0,320,270,4,"unlocked Easter level on the level page.");
    else
      write(0,320,250,4,"Impressive, make sure you try the next level now available");
      write(0,320,260,4,"on the choose level screen.");
    end
  end

  write(FNT_1,320,340,4,"Enter to continue to the main screen");
  while(!key(_enter))frame;end
  while(key(_enter))frame;end
  delete_text(all_text);
  clear_screen();
  menu();
  return;
end

end




//Add a process to the scroll
process add_scroll(pid)

begin

for(i=0;i<MAX_MEMBERS;i++)
  if(members[i] == 0)
     members[i] = pid;
     break;
  end
end

end


//Remove a process from the scroll
process remove_scroll(pid)

begin

for(i=0;i<MAX_MEMBERS;i++)
  if(members[i] == pid)
     break;
  end
end

for(;i<501;i++)
  members[i] = members[i+1];
end

end


process maintain_world()

begin

write_text();


loop
  //Adjust scores
  scores[RED] = get_ants_amount(RED);
  scores[BLUE]= get_ants_amount(BLUE);

  //Fix the scroll coordinates
  if(exists(sc.sid))
    sc.sx = sc.sid.xs/sc.sid.resolution - SCREENX/2;
    sc.sy = sc.sid.ys/sc.sid.resolution - SCREENY/2;
  end

  //Make sure border edges are respected
  if(sc.sx < sc.border[0])sc.sx = sc.border[0];end
  if(sc.sx > sc.border[2]-SCREENX)sc.sx = sc.border[2] - SCREENX;end
  if(sc.sy < sc.border[1])sc.sy = sc.border[1];end
  if(sc.sy > sc.border[3]-SCREENY)sc.sy = sc.border[3] - SCREENY;end


  //Correct all coordinates of the processes:
  for(i=0;exists(members[i]);i++)
    members[i].x = members[i].xs - sc.sx;
    members[i].y = members[i].ys - sc.sy;
  end


  //Draw world
  k = -(sc.sx % 64);
  l = -(sc.sy % 64);

  for(i=0;i<SCREENX/64+2;i++)
    for(j=0;j<SCREENY/64+2;j++)
      put(FPG_Game,background_pic,k+i*64+32,l+j*64+32);
    end
  end


  frame;
end//loop

end


//Add a light to the scroll
process add_light(x,y,typ)

begin

for(i=0;i<MAX_LIGHTS;i++)
  if(light[i].stype == 0)
    light[i].sx = x;
    light[i].sy = y;
    light[i].stype = typ;
    light[i].stime = 0;
    break;
  end
end

end


//Remove a light from the scroll
process remove_light(number)

begin

for(i=number;i<MAX_LIGHTS;i++)
  light[i].sx = light[i+1].sx;
  light[i].sy = light[i+1].sy;
  light[i].stime = light[i+1].stime;
  light[i].stype = light[i+1].stype;
end

end

//Returns the amount of lights
process get_lights_amount()

begin

while(light[i].stype != 0)
i++;
end
return i;

end

process get_ants_amount(colour)

begin

while(i = get_id(type ant))
  if(i.colour == colour)j++;end
end
return j;

end


//**********************************
//   ATTENTION
//   LudumDare roxxors
//**********************************


//A bug running around in the outside world
//============================================

process Ant(xs,ys,colour,level)

private
//maximum and minimum walking/idle graphics
maxg,ming;
idleg,animl;

mouseOut;

//next destination
destx,desty;
oldx,oldy;
isIdle;

timetogetthere;

toGo;
nearestLight;
collid;

tid;

begin
life = MAX_LIFE;


add_scroll(id);
switch(colour)
case BLUE:
  idleg =  1;
  ming  =  2;
  maxg  =  6;
end
case RED:
  idleg = 6;
  ming = 7;
  maxg = 11;
end
end


animl = 20;

isIdle = false;

if(colour == BLUE)
  eyes(BLUE);
else
  eyes(RED);
end

file = FPG_Game;
graph = idleg;

//Random start the animation counter:
i = rand(0,animl-1);

destx = xs + rand(-40,40);
desty = ys + rand(-40,40);


loop

  if(collision(type mouse))
    mouseOut = 80;
    if(tid == 0)
      tid = write_int(0,x,y-10,4,&life);
    else
      move_text(tid,x,y-10);
    end
  else
    mouseOut--;
    if(tid != 0)
      if(mouseOut <= 0)
        delete_text(tid);
        tid = 0;
      else
        move_text(tid,x,y-10);
      end
    end
  end


  //Animation code:
  i = ++i % animl;
  graph = idleg;
  if(!isIdle)
    graph = ming + (i*(maxg - ming) / animl);
  end



  if(isIdle)
    //Check if a lightsource is nearby, go towards it
    k = get_lights_amount();
    nearestLight = 0;
    for(j=0;j<k;j++)
      if(fget_dist(light[j].sx,light[j].sy,xs,ys) <= fget_dist(light[nearestLight].sx,light[nearestLight].sy,xs,ys))
        nearestLight = j;
      end
    end

    if(fget_dist(light[nearestLight].sx,light[nearestLight].sy,xs,ys)<170 and rand(0,100)<50)
      destx = xs + get_distx(fget_angle(xs,ys,light[nearestLight].sx,light[nearestLight].sy)+rand(-25,25)*1000,40);
      desty = ys + get_disty(fget_angle(xs,ys,light[nearestLight].sx,light[nearestLight].sy)+rand(-25,25)*1000,40);
      isIdle = false;
      timetogetthere = 40;
    end

    //if an enemy is nearby, ATTAQUE!
    if(isIdle)
      while(collID = get_id(type ant))
        if(get_dist(collID) < 35 and collID.colour != colour)
          destx = collID.xs;
          desty = collID.ys;
          isIdle = false;
          timetogetthere = 20;

          if(collision(collID) and collID.life >= 0)
            collID.life -= damage;
            if(collID.life < 0)
              //Death :-D
              level++;
              life += 70;
              //signal(collID,s_kill);
            end
            break;
          end

        end
      end
    end




    //Otherwise pick a random spot(maybe)
    if(rand(0,200)<40 and isIdle);
      destx = xs + rand(-40,40);
      desty = ys + rand(-40,40);
      timetogetthere = rand(35,50);
      isIdle = false;
    end
  else
    //Move towards new position
    timetogetthere--;
    if(timetogetthere == 0 or fget_dist(xs,ys,destx,desty)<5)
      isIdle = true;
    else
      angle = near_angle(angle,fget_angle(xs,ys,destx,desty),10000);
      xs += get_distx(angle,(50-timetogetthere)/20+1);
      ys += get_disty(angle,(50-timetogetthere)/20+1);
      if(collid = collision(type ant))
        //frame(0);
        xs -= get_distx(angle,(50-timetogetthere)/20);
        ys -= get_disty(angle,(50-timetogetthere)/20);
      end

    end
  end

  //Make the ants stay within the level limits
  if(xs < sc.border[0] + ANT_EDGE)xs = sc.border[0] + ANT_EDGE;end
  if(xs > sc.border[2] - ANT_EDGE)xs = sc.border[2] - ANT_EDGE;end
  if(ys < sc.border[1] + ANT_EDGE)ys = sc.border[1] + ANT_EDGE;end
  if(ys > sc.border[2] - ANT_EDGE)ys = sc.border[3] - ANT_EDGE;end

  //Calculate statistics every frame
  damage = 6 + (level-4)*3;
  size = 80 + level*5;

  if(life < 0)
    if(tid > 0)
      delete_text(tid);
    end
    break;
  end

  frame;
end

remove_scroll(id);

end

//Eyes of the bugs, glow in the dark
process eyes(colour)

begin
z = -10;

file = FPG_Game;

if(colour == RED)
  j = 16;
else
  j = 15;
end

i = father;

k = rand(0,20);

while(exists(i))
  k = ++k % 20;

  if(k > 10)
    graph = j;
  else
    graph = 0;
  end

  x = i.x;
  y = i.y;
  angle = i.angle;
  frame;
end

end



process overlay();

private
normal_light;
lightsize;
dark;

begin
z = -5;
graph = new_map(SCREENX,SCREENY,16);
map_clear(0,graph,rgb(5,5,5));
alpha = 190;
x = SCREENX/2;
y = SCREENY/2;

//Normal light:
normal_light = map_clone(FPG_Game,13);



loop
  //Determine darkness of the scene
  j = get_lights_amount();
  k=0;
  for(i=0;i<j;i++)
    if(fget_dist(sc.sx,sc.sy,light[i].sx,light[i].sy) < SCREENX)
      k+=(2-(fget_dist(sc.sx,sc.sy,light[i].sx,light[i].sy)/200))+1;
    end
  end
  if(k>5)
    dark = 120;
  else
    dark = 30+15*k;
  end

  //Clear the overlay map:
  map_clear(0,graph,rgb(dark,dark,dark));

  //put all lights on it:
  for(i=0;i<j;i++)
      switch(light[i].stype)
        case TYPE_NORMAL:
          //Normal light:
          if(light[i].stime > 250)
            //Timed out
            remove_light(i);
            i--;
            j--;
          else
            //In business
            xs = light[i].sx - sc.sx;
            ys = light[i].sy - sc.sy;

            //Light size depends on the time to live(getting bigger from the start, smaller to the end)
            switch(light[i].stime)
              case 0..50:
                lightsize = light[i].stime * 2;
              end
              case 1..217:
                lightsize = 100 + rand(-2,2);
              end
              case 217..250:
                lightsize = (250-light[i].stime)*3 + rand(-3,3);
              end
            end

            map_xput(0,graph,normal_light,xs,ys,0,lightsize,16);
            light[i].stime++;
          end

        end
      end
  end

  frame;
end



end














